;***********************************************************************
;                            GENCODE
;***********************************************************************
        include         macros.h
        include         "flib.h"
        include         "tios.h"
        xdef            _main
        xdef            _comment 

        _main:
                bsr     present
                clr.w   d3
                bsr     bclav
                rts

;***********************************************************************
        bclav:
                jsr     flib::idle_loop
                cmp.w   #97,d0
                beq     Adenine
                cmp.w   #117,d0
                beq     Uracile
                cmp.w   #99,d0
                beq     Cytosine
                cmp.w   #103,d0
                beq     Guanine
                cmp.w   #264,d0
                beq     done
                bra     bclav


         done:  rts

         Adenine: 
                move.w  #65,d1
                bsr     putbase
                lea     codonbuf,a0
                move.b  #2,0(a0,d3.w)
                bra endput
         
         Guanine: 
                move.w  #71,d1
                bsr     putbase
                lea     codonbuf,a0
                move.b  #3,0(a0,d3.w)
                bra endput
         
         Uracile: 
                move.w  #85,d1
                bsr     putbase
                lea     codonbuf,a0
                move.b  #0,0(a0,d3.w)
                bra endput
         
         Cytosine: 
                move.w  #67,d1
                bsr     putbase
                lea     codonbuf,a0
                move.b  #1,0(a0,d3.w)

        endput:
                add.w   #1,d3
                cmp.w   #3,d3
                beq     answer
                bra     bclav
                
        putbase:
                move.l  #$000000FF,-(a7)
                move.l  #$000100FF,-(a7)
                move.w  #55,-(a7)
                move.w  d3,d2
                mulu.w  #10,d2
                add.w   #90,d2
                move.w  d2,-(a7)

                move.w  d1,-(a7)
                jsr     tios::DrawCharXY
                add.l   #14,a7
                rts
;***********************************************************************
        answer:       
                lea     codonbuf,a0
                clr.l   d2
                move.b  (a0)+,d2
                lsl.w   #4,d2
                move.b  (a0)+,d1
                lsl.b   #2,d1
                add.b   d1,d2
                move.b  (a0)+,d1
                add.w   d1,d2

                lea     codon(pc),a0
                add.l   d2,a0
                move.b  (a0),d2
                lea     aamine(pc),a0
                add.l   d2,a0
                lea     codonbuf(pc),a1
                move.b  #2,d3
                cmp.w   #30,d2
                bne     loop
                move.b  #3,d3
        loop:   move.b  (a0)+,(a1)+
                dbf.b   d3,loop
                move.b  #0,(a1)
                SetFont #2
                WriteStr        #155,#53,#1,codonbuf
                
                jsr     flib::idle_loop
                cmp.w   #13,d0
                beq     _main

                rts

;***********************************************************************
        present:
                move.w  #70,-(a7)
                move.w  #216,-(a7)
                move.w  #26,-(a7)
                move.w  #24,-(a7)
                jsr     flib::erase_rect
                jsr     flib::frame_rect
                lea     8(a7),a7
                SetFont #0
                WriteStr        #49,#43,#1,me
                SetFont #2
                WriteStr        #56,#31,#1,_comment
                SetFont #1
                WriteStr        #34,#55,#1,arrow
                rts
;***********************************************************************
; STRINGS

codonbuf ds.b 5
_comment dc.b "Genetic Code 1.0",0
arrow dc.b "Codon ->",0
me dc.b "V. LE PRINCE <le-p2538@eurobretagne.fr>",0
include data.raw


        END
